import { useEditor } from "@/modules/editor";
import { onMounted, ref, inject, provide } from "vue";

export function useCompRef(compId: string) {
  const compRef = ref();
  const { helper } = useEditor();

  const parentId = compId !== "root" ? inject("compParentId") : "";
  provide("compParentId", compId);
  
  onMounted(() => {
    const comp = helper.findComp(compId);
    if (comp) {
      Object.defineProperties(comp, {
        $el: {
          value: compRef.value,
          configurable: true,
        },
        pid: {
          value: parentId,
          configurable: true,
        },
      });
    }
  });
  return compRef;
}
